<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglCommunicationSysMessage.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_d89ec3ddd84898ed9313f7a84ea735df.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglCommunicationSysMessage.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglCommunicationSysMessage_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLCOMMUNICATIONSYSMESSAGE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLCOMMUNICATIONSYSMESSAGE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"> * SYS_MESSAGE_CODE enumeration</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;{</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;   ADD_VERTEX_INFO = 0,   <span class="comment">// adding vertex pos information to the position hash table</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;   REMOVE_VERTEX_INFO,   <span class="comment">// removing vertex information (vertex is deleted)</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;   UPDATE_VERTEX_INFO,   <span class="comment">// changing the vertex pos info in the position hash table</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">//  ADD_EDGE, </span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">//  REMOVE_EDGE, </span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;   GET_VERTEX_POS,   <span class="comment">// request a position of a given vertex</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;   INFO_VERTEX_POS,   <span class="comment">// provides the device position of a given vertex</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;   VERTEX_NOT_EXIST,</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">//    ERR_RCVR_NOT_EXIST, </span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;   UNDEFINED_MESSAGE,</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;   AGGREGATE_INFO,</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;   DEV_IDLE,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;   HALT</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;} SYS_MESSAGE_CODE;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword">inline</span> SYS_MESSAGE_CODE getMessageCode(uint8_t *buf)</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;{</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;   SYS_MESSAGE_CODE code = (SYS_MESSAGE_CODE) *(buf++);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;   <span class="keywordflow">return</span> code;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment"> * TIGLCommunicationSysMessage class</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html">   96</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLCommunicationSysMessage.html">TIGLCommunicationSysMessage</a></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;{</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">    * Constructor/Destructor</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#ad04c3abc8673b101c87b032c0dd3815f">  114</a></span>&#160;   <a class="code" href="classTIGLCommunicationSysMessage.html#ad04c3abc8673b101c87b032c0dd3815f">TIGLCommunicationSysMessage</a>(SYS_MESSAGE_CODE code, uint_fast32_t dev, MESSAGE_TYPE *message)</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;      messageCode = code;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      otherDevice = dev;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;      messageBody.clear();</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      uint8_t *messageBytes = (uint8_t *) message;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;      messageBody.insert(messageBody.begin(), messageBytes, messageBytes + <span class="keyword">sizeof</span>(MESSAGE_TYPE));</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   }</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a34a484fc4418bb5415ff2f9f4b8f3a7a">  133</a></span>&#160;   <a class="code" href="classTIGLCommunicationSysMessage.html#a34a484fc4418bb5415ff2f9f4b8f3a7a">TIGLCommunicationSysMessage</a>(SYS_MESSAGE_CODE code, uint_fast32_t dev)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;   {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;      messageCode = code;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;      otherDevice = dev;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      messageBody.clear();</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   }</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00148"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a20946f6bc1a04fed8757ef9552a825b7">  148</a></span>&#160;   <a class="code" href="classTIGLCommunicationSysMessage.html#a20946f6bc1a04fed8757ef9552a825b7">TIGLCommunicationSysMessage</a>()</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;      messageCode = UNDEFINED_MESSAGE;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;      messageBody.clear();</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   }</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   ~<a class="code" href="classTIGLCommunicationSysMessage.html">TIGLCommunicationSysMessage</a>()</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;   {</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   }</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#afcd4039732a2d4d5a63d0238a122e674">  165</a></span>&#160;   SYS_MESSAGE_CODE <a class="code" href="classTIGLCommunicationSysMessage.html#afcd4039732a2d4d5a63d0238a122e674">messageCode</a>;</div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a4375c638dcde775cd5bc5ab143ecb447">  167</a></span>&#160;   vector&lt;uint8_t&gt; <a class="code" href="classTIGLCommunicationSysMessage.html#a4375c638dcde775cd5bc5ab143ecb447">messageBody</a>;</div>
<div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#aa716afbd62ad897695da8dc0a8944b10">  169</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLCommunicationSysMessage.html#aa716afbd62ad897695da8dc0a8944b10">otherDevice</a>;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#ad6bc9a80d87ef57cacd5d80be26d7068">  182</a></span>&#160;   <span class="keyword">inline</span> SYS_MESSAGE_CODE <a class="code" href="classTIGLCommunicationSysMessage.html#ad6bc9a80d87ef57cacd5d80be26d7068">getMessageCode</a>()</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;   {</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;      <span class="keywordflow">return</span> messageCode;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;   }</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00192"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#ae7dbe83d2e2e801f4662181f5e55b009">  192</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationSysMessage.html#ae7dbe83d2e2e801f4662181f5e55b009">hasBody</a>()</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;   {</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;      <span class="keywordflow">return</span> (messageBody.size() &gt; 0);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;   }</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00202"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#afc9eb4300aa565030b20b9a142ed7f9a">  202</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLCommunicationSysMessage.html#afc9eb4300aa565030b20b9a142ed7f9a">getSizeInBytes</a>()</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;   {</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;      <span class="keywordflow">return</span> messageBody.size() + 1;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;   }</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00212"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#af1c1b70e022fde4ab672283573c35eb0">  212</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLCommunicationSysMessage.html#af1c1b70e022fde4ab672283573c35eb0">getDst</a>()</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;   {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;      <span class="keywordflow">return</span> otherDevice;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;   }</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a69dfcfadc0fb670b3a4cd165cc5a6e75">  226</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLCommunicationSysMessage.html#a69dfcfadc0fb670b3a4cd165cc5a6e75">pack</a>(uint8_t *buf)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;   {</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;      <span class="comment">// putting the message code and the system message flag</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;      uint8_t firstByte = (uint8_t) messageCode;    <span class="comment">// | IS_SM_MASK;</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;      *(buf++) = firstByte;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;      uint_fast32_t messageSize = getSizeInBytes();</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;      <span class="keywordflow">if</span> (messageSize &gt; 1)</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      {</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;         std::copy(messageBody.begin(), messageBody.end(), buf);</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      }</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;      <span class="keywordflow">return</span> messageSize;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;   }</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00247"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a5624a06125b6260597691a1664e29805">  247</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLCommunicationSysMessage.html#a5624a06125b6260597691a1664e29805">unpack</a>(uint8_t *buf, uint_fast32_t numBytes)</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;   {</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;      messageCode = (SYS_MESSAGE_CODE) (*(buf++));</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;      messageBody.clear();</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;      <span class="keywordflow">if</span> (numBytes &gt; 1)</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;      {</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;         messageBody.insert(messageBody.begin(), buf, buf + numBytes - 1);   <span class="comment">//std::copy(buf, buf+numBytes-1, messageBody.begin());</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;      }</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;   }</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00266"></a><span class="lineno"><a class="line" href="classTIGLCommunicationSysMessage.html#a4febc9dd66edd3bcc1d2f15914431732">  266</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLCommunicationSysMessage.html#a4febc9dd66edd3bcc1d2f15914431732">readMessageBody</a>(MESSAGE_TYPE *message)</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;   {</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;      <span class="keywordflow">if</span> (messageBody.size() != <span class="keyword">sizeof</span>(MESSAGE_TYPE))</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;      {</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;XXX ERROR bodySize = &quot;</span> &lt;&lt; messageBody.size() &lt;&lt; <span class="stringliteral">&quot;/&quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(MESSAGE_TYPE) &lt;&lt; endl;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;         <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;      }</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;      uint8_t *p = (uint8_t *) message;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;      std::copy(messageBody.begin(), messageBody.end(), p);</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;   }</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;};</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCOMMUNICATIONSYSMESSAGE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_ad04c3abc8673b101c87b032c0dd3815f"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#ad04c3abc8673b101c87b032c0dd3815f">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage(SYS_MESSAGE_CODE code, uint_fast32_t dev, MESSAGE_TYPE *message)</div><div class="ttdoc">Constructor set the fields of the system message. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:114</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_afc9eb4300aa565030b20b9a142ed7f9a"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#afc9eb4300aa565030b20b9a142ed7f9a">TIGLCommunicationSysMessage::getSizeInBytes</a></div><div class="ttdeci">uint_fast32_t getSizeInBytes()</div><div class="ttdoc">Reads the variable-size message body. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:202</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a4375c638dcde775cd5bc5ab143ecb447"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a4375c638dcde775cd5bc5ab143ecb447">TIGLCommunicationSysMessage::messageBody</a></div><div class="ttdeci">vector&lt; uint8_t &gt; messageBody</div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:167</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a20946f6bc1a04fed8757ef9552a825b7"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a20946f6bc1a04fed8757ef9552a825b7">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage()</div><div class="ttdoc">Overloaded constructor for an system message. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:148</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a5624a06125b6260597691a1664e29805"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a5624a06125b6260597691a1664e29805">TIGLCommunicationSysMessage::unpack</a></div><div class="ttdeci">void unpack(uint8_t *buf, uint_fast32_t numBytes)</div><div class="ttdoc">Unpacks a system message to the object fields. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:247</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a4febc9dd66edd3bcc1d2f15914431732"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a4febc9dd66edd3bcc1d2f15914431732">TIGLCommunicationSysMessage::readMessageBody</a></div><div class="ttdeci">bool readMessageBody(MESSAGE_TYPE *message)</div><div class="ttdoc">Converts a packed format to a customized message format. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:266</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_aa716afbd62ad897695da8dc0a8944b10"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#aa716afbd62ad897695da8dc0a8944b10">TIGLCommunicationSysMessage::otherDevice</a></div><div class="ttdeci">uint_fast32_t otherDevice</div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:169</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_ad6bc9a80d87ef57cacd5d80be26d7068"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#ad6bc9a80d87ef57cacd5d80be26d7068">TIGLCommunicationSysMessage::getMessageCode</a></div><div class="ttdeci">SYS_MESSAGE_CODE getMessageCode()</div><div class="ttdoc">Returns the system message code. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:182</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a69dfcfadc0fb670b3a4cd165cc5a6e75"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a69dfcfadc0fb670b3a4cd165cc5a6e75">TIGLCommunicationSysMessage::pack</a></div><div class="ttdeci">uint_fast32_t pack(uint8_t *buf)</div><div class="ttdoc">Packs the system message into bytes. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:226</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_af1c1b70e022fde4ab672283573c35eb0"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#af1c1b70e022fde4ab672283573c35eb0">TIGLCommunicationSysMessage::getDst</a></div><div class="ttdeci">uint_fast32_t getDst()</div><div class="ttdoc">Reads the destination device. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:212</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html">TIGLCommunicationSysMessage</a></div><div class="ttdoc">Core system message class definition. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:96</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_a34a484fc4418bb5415ff2f9f4b8f3a7a"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#a34a484fc4418bb5415ff2f9f4b8f3a7a">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage(SYS_MESSAGE_CODE code, uint_fast32_t dev)</div><div class="ttdoc">Overloaded constructor for system messages that do not have a body. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:133</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_afcd4039732a2d4d5a63d0238a122e674"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#afcd4039732a2d4d5a63d0238a122e674">TIGLCommunicationSysMessage::messageCode</a></div><div class="ttdeci">SYS_MESSAGE_CODE messageCode</div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:165</div></div>
<div class="ttc" id="classTIGLCommunicationSysMessage_html_ae7dbe83d2e2e801f4662181f5e55b009"><div class="ttname"><a href="classTIGLCommunicationSysMessage.html#ae7dbe83d2e2e801f4662181f5e55b009">TIGLCommunicationSysMessage::hasBody</a></div><div class="ttdeci">bool hasBody()</div><div class="ttdoc">Checks if the message has a body. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:192</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
